// Java-Rechenbaum-Programm, fr IF12M  -- Krell, 19.7.04  (www.r-krell.de)

import java.io.*;

public class Rb_Rechenbaum     // Datei ergnzen, in Rb_Rechenbaum.java umbenennen und kompilieren!
{
  Rb_Knoten wurzel = null;

  //----------------------------------------------------------------

  public boolean istLeer()
  {
    return (wurzel == null);
  }

  //----------------------------------------------------------------

  public String term2Baum (String term)
  {
    wurzel = null;                // Neuen Baum anfangen
    Rb_Knoten voraktuell = null;  // voaraktuell zeigt auf den Knoten, an den die nchste Zahl rechts dran soll
    for (int i=0; i<term.length(); i++)    // Term zeichenweise einlesen und jedes nchste..
    {                                      // .. Zeichen passend in den Baum einbauen
      voraktuell = rein (term.charAt(i), voraktuell);
    }
    return (zeigeStruktur());     // Erzeugten Baum zur Kontrolle darstellen
  }
  
  private Rb_Knoten rein (char zchn, Rb_Knoten voraktuell)
  {
    // Neuen Inhalt el und neuen, mit el gefllten Knoten kn erzeugen:
    double zahl = Double.NaN;     // NaN = not a number = noch keine gltige Zahl
    String text = ""+zchn;        // Eingabezeichen speichern
    if (zchn >= '0' && zchn <= '9')     // Falls Eingabezeichen eine Ziffer ist,..
    {
      zahl = Double.parseDouble(text);  // in Zahl umwandeln und als solche speichern
      text = "z"; // Kennzeichen fr Zahl!
    }
    Rb_Baumelement el = new Rb_Baumelement (text,zahl);  // text und zahl zu Element zusammenfassen
    Rb_Knoten kn = new Rb_Knoten(el);   // Neuen Knoten mit Inhalt el erzeugen, re und li = null
    
    // Knoten kn an der richtigen Stelle im Baum einbauen:




    return (voraktuell);
  }
  
  //----------------------------------------------------------------

  public String baum2Term()
  {
    String term = "-- (Baum leer)";
    if (!istLeer())
    {
    
      term = "(noch nicht implementiert)";
    }
    return (term);
  }

  //----------------------------------------------------------------

  public double baum2Ergebnis()
  {
    double resultat = Double.NaN; //NaN = not a number = ungltig, da noch nicht berechnet
    if (!istLeer())
    {

    }
    return (resultat);
  }

  //----------------------------------------------------------------
  // Die folgende Methode wurde aus F_Sortierbaum bernommen, damit sie
  // eventuell fr eine der vorstehenden Aufgaben angepasst werden kann:
  
  public String lwrAusgabe ()
  {
    return (rekLWR (wurzel, ""));
  }
  
  private String rekLWR (Rb_Knoten knoten, String aus)
  {
    if (knoten != null)
    {
      aus = rekLWR (knoten.li, aus);                    // L
      aus = aus + " " + knoten.inhalt.zeigeElement();   // W
      aus = rekLWR (knoten.re, aus);                    // R
    }
    return (aus);
  }

  //----------------------------------------------------------------


  //------------------------------------------------------
  // Die Methode zeigeStruktur, die ich hier vorgebe (und
  // deren genaue Arbeistweise nicht verstanden werden muss) ist der
  // Grund fr diesen UrBaum: so kann jeder hiervon abgeleitete Baum
  // diese Methode zur Selbstdarstellung erben! -- 12.7.04 k

  // rekursive Hilfsmethode fr zeigeStruktur
    private void rekStruktur (String[] zeile, Rb_Knoten knoten, int x, int y, int n)
    {
      if (knoten != null)
      {
//        System.out.println("* y="+y+"  x="+x );
        if (zeile[y-1].charAt(x) == '-')
        {
          zeile[y-1] = zeile[y-1].substring(0,x) + "." + zeile[y-1].substring(x+1);
        }
        if (y<7)
        {
          String striche = "-------------------------------------------------------------------------------------------";
          n = n*2;
          int x_li = x - 43/n;
          int x_re = x + 43/n;
          String schl = knoten.inhalt.zeigeElement();
          int len = schl.length();
          zeile[y] = zeile[y].substring(0,x_li)+"-"+striche.substring(x_li, x_re)+"-"+zeile[y].substring(x_re+1);
          zeile[y] = zeile[y].substring(0,x-len/2)+schl+zeile[y].substring(x-len/2+len+1);
          if (y<7)
          {
            rekStruktur (zeile, knoten.li, x_li, y+1, n);
            rekStruktur (zeile, knoten.re, x_re, y+1, n);
          }
        }
        else
        {
          if (! zeile[6].endsWith("(Weitere Ebenen nicht angezeigt!)\n"))
          {
            zeile[6] = zeile[6]+"(Weitere Ebenen nicht angezeigt!)\n";
          }
        }
      }
    } // rekZeige

  public String zeigeStruktur ()
  // stellt den gesamten Baum grafisch dar
  {
    String leer    = "                                                                                             \n";
    String[] zeile = new String[7];
    for (int y=0; y < 7; y++)
    {
      zeile[y] = leer;
    }
    zeile[0] = "Baumstruktur :"+zeile[0].substring(0,29)+"-  \n";

    rekStruktur (zeile, wurzel, 43, 1, 1);

    for (int y=1; y < 7; y++)
    {
      if (! zeile[y].equals(leer))
      {
        zeile[0] = zeile[0] + zeile[y];
      }
    }
    return (zeile[0]);
  }

}
